/***************************************/
/*                                     */
/*         例題 オイラー定数の計算         */
/*                                     */
/***************************************/

#include<stdio.h>
#include<math.h>

int main(void)
{
    /*計算で必要な変数*/
    int i, j;
	double sum1, sum2, tmp, dst;
	
	/* 1/1 から 1/10000 までの総和を求めるための変数の準備 */
	sum1 = 0.0;
	
	/* 1/10000 から 1/1 までの総和を求めるための変数の準備 */
	sum2 = 0.0;
	
	/* 1/1 から 1/10000 まで順に加える操作 */
	for(i=1;i<=10000;i++)
	{
		/* 各足し算を実行 */
		sum1 = sum1 + 1.0/i;
		
		/* 計算後の有効数字7桁目を四捨五入 */
		for(j=0;j<=100;j++)
		{
			tmp = sum1 * pow(10,j);
			if( 5.0 <= log10(tmp) && log10(tmp) < 6.0 )
			{
				if( tmp - (double)(int)tmp < 0.5 )
				dst = (double)(int)tmp;
				else
				dst = (double)(int)(tmp+0.6);
				
				sum1=dst*pow(10,-j);
				break;
			}
		}
	}

	/* 1/10000 から 1/1 まで順に加える操作 */
	for(i=10000;i>=1;i--)
	{
		/* 各足し算を実行 */
		sum2 = sum2 + 1.0/i;
		
		/* 計算後の有効数字7桁目を四捨五入 */
		for(j=0;j<=100;j++)
		{
			tmp = sum2 * pow(10,j);
			if( 5.0 <= log10(tmp) && log10(tmp) < 6.0)
			{
				if( tmp-(double)(int)tmp < 0.5 )
				dst = (double)(int)tmp;
				else
				dst = (double)(int)(tmp+0.6);
				
				sum2=dst*pow(10,-j);
				break;
			}
		}
	}
	
	/* それぞれの足し算結果を表示 */
	printf("sum1=%f sum2=%f\n",sum1, sum2);
    /* log(10000.0)の値を表示 */
	printf("log(10000)=%f\n",log(10000.0));
	/* それぞれの足し算結果をもとにオイラーの定数を表示 */
	printf("gamma1=%f gamma2=%f\n",sum1-log(10000.0), sum2-log(10000.0));
}
