/***************************************/
/*                                     */
/*     例題2.4 ニュートン法のプログラム     */
/*                                     */
/***************************************/

#include<stdio.h>
#include<math.h>

/*関数の定義*/
#define f(X) (pow((X),5.0)+(X)-1.0)
#define Df(X) (5.0*pow((X),4.0)+1.0)

int main(void)
{
    /*計算で必要な変数*/
    int i;
	double x, new_x;
	
	/*初期値を設定*/
	x=0.5;

	/*ニュートン法を用いて計算*/
	for(i=0;i<=10;i++)
	{
		/*結果を表示*/
		printf("x%d=%f f(x)=%f\n",i,x,f(x));
		
		/*x_nからx_(n+1)を計算*/
		new_x = x-f(x)/Df(x);
		
		/*次の計算のための値の更新*/
		x=new_x;
	}
}


