/***********************************************/
/*                                             */
/*    例題3.1 一次因子の組み立て除法のプログラム     */
/*                    一回目                    */
/*                                             */
/***********************************************/


#include<stdio.h>
#include<math.h>
#include<complex.h>

#define a0 (1.0)
#define a1 (3.0)
#define a2 (2.0*I)
#define a3 (-4.0)
#define a4 (-2.0)
#define a5 (I)

#define f(X) ( a0*(X)*(X)*(X)*(X)*(X)+a1*(X)*(X)*(X)*(X)+a2*(X)*(X)*(X)+a3*(X)*(X)+a4*(X)+a5 )
#define Df(X) ( 5.0*a0*(X)*(X)*(X)*(X)+4.0*a1*(X)*(X)*(X)+3.0*a2*(X)*(X)+2.0*a3*(X)+a4 )

int main(void)
{
    /*計算で必要な変数*/
    int i;
	double complex x;
	double complex b1, b2, b3, b4;
	
	/*初期値を設定*/
	x=I;
	
	/*複素ニュートン法の実行*/
	/*20回繰り返す*/
	for(i=0;i<=20;i++)
	{
		/*ニュートン法の結果の表示*/
        printf("%d %f%+fi %f%+fi\n",i,creal(x),cimag(x),creal(f(x)),cimag(f(x)));
		
		x=x-f(x)/Df(x);
	}
	
	/*次の代数方程式の係数の計算*/
	b1 = a1 +      x;
	b2 = a2 + b1 * x;
	b3 = a3 + b2 * x;
	b4 = a4 + b3 * x;
	
	/*(x-alpha)で割って得られる代数方程式の係数の表示*/
	printf( "b1=%f%+fi\n",creal(b1),cimag(b1) );
	printf( "b2=%f%+fi\n",creal(b2),cimag(b2) );
	printf( "b3=%f%+fi\n",creal(b3),cimag(b3) );
	printf( "b4=%f%+fi\n",creal(b4),cimag(b4) );
}


