/*************************************/
/*                                   */
/*     例題7.1 オイラー法のプログラム     */
/*                                   */
/*************************************/

#include<stdio.h>
#include<math.h>

int main(void)
{
    /*計算に必要な変数*/
    int i, N;
	double T, h, t, x0, x, exact_x, new_x;
	
    /*時間, 初期値, 分割数の設定*/
	T=2.0;
	x0=0.1;
	N=20;//分割数を変える場合はこの値を変更
	
	/*時間刻み幅の設定*/
	h=T/N;
    x=x0;
	
    /*オイラー法による時間発展*/
	for(i=0;i<=N;i++)
	{
		t=h*i;
		new_x=x+h*( (1.0-x)*x );
		
        /*厳密解*/
        exact_x=x0*exp(t)/((exp(t)-1.0)*x0+1.0);
        
        /*結果の出力*/
		printf("%f %f %f %f\n",t, x, x-exact_x,(x-exact_x)/h);
		x=new_x;
	}
}


