/******************************************/
/*                                        */
/*     例題2.3 エイトケンの加速のプログラム     */
/*                                        */
/******************************************/

#include<stdio.h>
#include<math.h>

/*エイトケンの加速の式を定義する*/
#define A(U,V,W) ( (W)-((W)-(V))*((W)-(V))/((W)-2.0*(V)+(U)) )

int main(void)
{
    /*計算で必要な変数*/
    int i;
	double new_x, x, old_x, X;
	
	/*初期値を設定*/
    old_x=0.5;
	x=cos(old_x);
	
	for(i=0;i<=20;i++)
	{
		/*反復法で{x_n}を生成*/
		new_x=cos(x);
		
        /*Aitkenの加速を適用*/
        X=A(old_x,x,new_x);
        
        /*結果を表示*/
        printf("x_%d=%f\n",i,X);
        
        /*次のステップのために数値を更新*/
        old_x=x;
        x=new_x;
	}
}


