/***********************************************/
/*                                             */
/*    例題3.1 一次因子の組み立て除法のプログラム     */
/*                    三回目                    */
/*                                             */
/***********************************************/

#include<stdio.h>
#include<math.h>
#include<complex.h>

#define a0 (1.0)
#define a1 (2.344977+0.275690*I)
#define a2 (-1.507351+2.698503*I)
#define a3 (-3.575285-1.608850*I)

#define f(X) ( a0*(X)*(X)*(X)+a1*(X)*(X)+a2*(X)+a3 )
#define Df(X) ( 3.0*a0*(X)*(X)+2.0*a1*(X)+a2 )

int main(void)
{
    /*計算で必要な変数*/
    int i;
	double complex x;
	double complex b1, b2;
	
	/*初期値を設定*/
	x=I;
	
	/*ニュートン法の実行*/
	/*20回繰り返す*/
	for(i=0;i<=20;i++)
	{
		/*ニュートン法の結果の表示*/
		printf("%d %f%+fi %f+%+fi\n",i,creal(x),cimag(x),creal(f(x)),cimag(f(x)));
		
		x=x-f(x)/Df(x);
	}
	
	/*次の代数方程式の係数の計算*/
	b1 = a1 +      x;
	b2 = a2 + b1 * x;
	
	/*(x-alpha)で割って得られる代数方程式の係数の表示*/
	printf( "b1=%f%+fi\n",creal(b1),cimag(b1) );
	printf( "b2=%f%+fi\n",creal(b2),cimag(b2) );
}


