/***********************************************/
/*                                             */
/*    例題3.1 一次因子の組み立て除法のプログラム     */
/*                    四回目                    */
/*                                             */
/***********************************************/

#include<stdio.h>
#include<math.h>
#include<complex.h>

#define a0 (1.0)
#define a1 (1.665997-0.591480*I)
#define a2 (-3.151444+1.655404*I)

#define f(X) ( a0*(X)*(X)+a1*(X)+a2 )
#define Df(X) ( 2.0*a0*(X)+a1 )

int main(void)
{
    /*計算で必要な変数*/
    int i;
	double complex x;
	double complex b1;
	
	/*初期値を設定*/
	x=I;
	
	/*ニュートン法の実行*/
	/*20回繰り返す*/
	for(i=0;i<=20;i++)
	{
		/*ニュートン法の結果の表示*/
		printf("%d %f%+fi %f%+fi\n",i,creal(x),cimag(x),creal(f(x)),cimag(f(x)));
		
		x=x-f(x)/Df(x);
	}
	
	/*次の代数方程式の係数の計算*/
	b1 = a1 +      x;
	
	/*(x-alpha)で割って得られる代数方程式の係数の表示*/
	printf( "b1=%f%+fi\n",creal(b1),cimag(b1) );
}


