/****************************************************/
/*                                                  */
/*     例題6.1 複合中点公式を用いた数値積分のプログラム     */
/*                                                  */
/****************************************************/

#include<stdio.h>
#include<math.h>

int main(void)
{
    /*計算に必要な変数*/
    int i, N;
	double h, sum, x;
	
    /*区間をN分割する*/
    N=100;
	h=1.0/N;
    
    /*各小区間ごとに中点公式で計算し, それらを足し合わせる*/
    sum=0.0;
    for(i=0;i<N;i++)
    {
        x = (i+0.5)*h;
        sum = sum + h* exp(-x*x);
    }
	
    /*結果の表示*/
	printf("%f\n",sum);
}


