/****************************************************/
/*                                                  */
/*     例題6.2 複合台形公式を用いた数値積分のプログラム     */
/*                                                  */
/****************************************************/

#include<stdio.h>
#include<math.h>

int main(void)
{
    /*計算に必要な変数*/
    int i,N;
	double h, sum;
	
    /*区間をN分割する*/
    N=100;
	h=1.0/N;
	
    /*各小区間ごとに台形公式で計算し, それらを足し合わせる*/
	sum=0.0;
	for(i=0;i<N;i++)
	{
		sum=sum+(h/2.0)*( exp(-((i+1)*h)*((i+1)*h))+exp(-(i*h)*(i*h)) );
	}
	
    /*結果の表示*/
	printf("%f\n",sum);
}


