/********************************************************/
/*                                                      */
/*     例題6.4 ガウスの積分公式を用いた数値積分のプログラム     */
/*                                                      */
/********************************************************/

#include<stdio.h>
#include<math.h>

#define f(t) ( 8.0/((t)*(t)+2.0*(t)+5.0) )

int main(void)
{
    /*計算に必要な変数*/
    double x1,x2,x3,x4,x5,w1,w2,w3,sum;
	
    /*n=2のとき*/
    x1=-0.5773502692;
    x2= 0.5773502692;
    w1=1.0;
    sum=w1*f(x1)+w1*f(x2);
    printf("n=2 %f %f\n",sum,sum-M_PI);

    /*n=3のとき*/
    x1=-0.7745966692;
    x2=0.0;
    x3= 0.7745966692;
    w1=0.5555555555;
    w2=0.8888888889;
    sum=w1*f(x1)+w2*f(x2)+w1*f(x3);
    printf("n=3 %f %f\n",sum,sum-M_PI);

    /*n=4のとき*/
    x1=-0.8611363116;
    x2=-0.3399810436;
    x3= 0.3399810436;
    x4= 0.8611363116;
    w1=0.3478548451;
    w2=0.6521451549;
    sum=w1*f(x1)+w2*f(x2)+w2*f(x3)+w1*f(x4);
    printf("n=4 %f %f\n",sum,sum-M_PI);

    /*n=5のとき*/
    x1=-0.9061798459;
    x2=-0.5384693101;
    x3= 0.0;
    x4= 0.5384693101;
    x5= 0.9061798459;
    w1=0.2369268851;
    w2=0.4786286705;
    w3=0.5688888889;
    sum=w1*f(x1)+w2*f(x2)+w3*f(x3)+w2*f(x4)+w1*f(x5);
    printf("n=5 %f %f\n",sum,sum-M_PI);
}


